# -*- coding: utf-8 -*-
"""VendorDashboardCompute.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1a8HBNvsuDhWGtfRAbJdfUfxBb5ug_nYP
"""

import numpy as np
from sqlalchemy import create_engine
import pandas as pd
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
connn = engine.connect()

vendorrank = pd.read_sql("""SELECT * FROM (SELECT name,sum(selectedcount) as storeselected FROM (SELECT * FROM (SELECT store,selectedcount,stores.name FROM (SELECT store,count(store) as selectedcount FROM (SELECT  SUBSTRING_INDEX(SUBSTRING_INDEX(SUBSTRING_INDEX(event_parameters, "'Store_ID':", -1),", 'User_ID'",1),'}',1) as 'store',
date(created_on) as createdon
FROM stepuplogs.audit_trails
where event_name='Click_StoreSelected'
and created_on > curdate() - interval 30 day) AS A
group by store) AS B
left join stores on stores.id= B.store) AS C
order by selectedcount desc) AS D
group by name
order by sum(selectedcount) desc) AS E
  """, con=connn)
vendorrank=vendorrank.reset_index()
vendorrank['index']=vendorrank['index']+1
vendorrank.columns=['rank', 'name', 'totalviews']
vendorrank['totalviews'].max()
vendorrank['nextvendorviews']=vendorrank['totalviews'][1:].reset_index()['totalviews']
vendorrank['beforevendorviews']=vendorrank['totalviews'].shift(1)
vendorrank['higher']=(vendorrank['beforevendorviews']-vendorrank['totalviews'])/vendorrank['beforevendorviews']*100
vendorrank['lower']=(vendorrank['nextvendorviews']-vendorrank['totalviews'])/vendorrank['nextvendorviews']*100

engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()

# # # Read
# #Todays_Opportunity = pd.read_sql('select * from Todays_Opportunity;', con=con) 
vendorrank.to_sql(con=con, name='vendorrank', if_exists='replace',index=False)
con.close()

"""**Position By Sales**"""

salesrank = pd.read_sql("""SELECT name,sold,case when pincodestart = 400 then 'Mumbai'
when pincodestart='411' then 'pune' when pincodestart = 410 then 'Lonavala'
else 'other' end as 'cityname' FROM (SELECT name,pincodestart,sum(nettotal) as sold FROM (SELECT Date(orders.created_on) as 'orderdate',orders.net_total as nettotal,stores.name,
left (orders.shipping_pincode,3) as pincodestart  FROM turant.orders
inner join stores on stores.id=orders.store_id
where orders.created_on between curdate() - interval 30 day
and curdate()
and orders.payment_status=1) AS A
group by name,pincodestart) AS B
  """, con=connn)
vendorsales=pd.pivot_table(salesrank,index='name',columns='cityname',values='sold',aggfunc='sum').reset_index()
vendorsales=vendorsales.sort_values('Mumbai',ascending=False)
vendorsales['MumbaiNext']=vendorsales['Mumbai'].shift(1)
vendorsales['MumbaiBefore']=vendorsales['Mumbai'].shift(-1)
vendorsales['Mumbaihigher']=(vendorsales['MumbaiNext']-vendorsales['Mumbai'])/vendorsales['MumbaiNext']*100
vendorsales['Mumbailower']= (vendorsales['MumbaiBefore']-vendorsales['Mumbai'])/vendorsales['MumbaiBefore']*100

vendorsales=vendorsales.sort_values('pune',ascending=False)
vendorsales['puneNext']=vendorsales['pune'].shift(1)
vendorsales['puneBefore']=vendorsales['pune'].shift(-1)
vendorsales['punehigher']= (vendorsales['puneNext']-vendorsales['pune'])/vendorsales['puneNext']*100
vendorsales['punelower']=(vendorsales['puneBefore']-vendorsales['pune'])/vendorsales['puneBefore']*100

vendorsales=vendorsales.sort_values('Lonavala',ascending=False)
vendorsales['LonavalaNext']=vendorsales['Lonavala'].shift(1)
vendorsales['LonavalaBefore']=vendorsales['Lonavala'].shift(-1)
vendorsales['Lonavalahigher']=(vendorsales['LonavalaNext']-vendorsales['Lonavala'])/vendorsales['LonavalaNext']*100
vendorsales['Lonavalalower']= (vendorsales['LonavalaBefore']-vendorsales['Lonavala'])/vendorsales['LonavalaBefore']*100
vendorsales=vendorsales.replace([np.inf, -np.inf], np.nan)
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()

# # # Read
# #Todays_Opportunity = pd.read_sql('select * from Todays_Opportunity;', con=con) 
vendorsales.to_sql(con=con, name='vendorsales', if_exists='replace',index=False)
con.close()

"""TicketEfficiency"""

ticketrank = pd.read_sql("""SELECT name,sold,case when pincodestart = 400 then 'Mumbai'
when pincodestart='411' then 'pune' when pincodestart = 410 then 'Lonavala'
else 'other' end as 'cityname',ordervalue FROM (SELECT name,pincodestart,sum(nettotal) as sold,count(nettotal) as ordervalue FROM (SELECT Date(orders.created_on) as 'orderdate',orders.net_total as nettotal,stores.name,
left (orders.shipping_pincode,3) as pincodestart  FROM turant.orders
inner join stores on stores.id=orders.store_id
where orders.created_on between curdate() - interval 30 day
and curdate()
and orders.payment_status=1) AS A
group by name,pincodestart) AS B
  """, con=connn)
ticketrank['avgsizeperorder']=ticketrank['sold']/ticketrank['ordervalue']
vendorticket= pd.pivot_table(ticketrank,index='name',columns='cityname',values='avgsizeperorder',aggfunc='sum').reset_index()
vendorticket=vendorticket.sort_values('Mumbai',ascending=False)
vendorticket['MumbaiNext']=vendorticket['Mumbai'].shift(1)
vendorticket['MumbaiBefore']=vendorticket['Mumbai'].shift(-1)
vendorticket['Mumbaihigher']=(vendorticket['MumbaiNext']-vendorticket['Mumbai'])/vendorticket['MumbaiNext']*100
vendorticket['Mumbailower']= (vendorticket['MumbaiBefore']-vendorticket['Mumbai'])/vendorticket['MumbaiBefore']*100

vendorticket=vendorticket.sort_values('pune',ascending=False)
vendorticket['puneNext']=vendorticket['pune'].shift(1)
vendorticket['puneBefore']=vendorticket['pune'].shift(-1)
vendorticket['punehigher']= (vendorticket['puneNext']-vendorticket['pune'])/vendorticket['puneNext']*100
vendorticket['punelower']=(vendorticket['puneBefore']-vendorticket['pune'])/vendorticket['puneBefore']*100

vendorticket=vendorticket.sort_values('Lonavala',ascending=False)
vendorticket['LonavalaNext']=vendorticket['Lonavala'].shift(1)
vendorticket['LonavalaBefore']=vendorticket['Lonavala'].shift(-1)
vendorticket['Lonavalahigher']=(vendorticket['LonavalaNext']-vendorticket['Lonavala'])/vendorticket['LonavalaNext']*100
vendorticket['Lonavalalower']= (vendorticket['LonavalaBefore']-vendorticket['Lonavala'])/vendorticket['LonavalaBefore']*100

vendorticket=vendorticket.replace([np.inf, -np.inf], np.nan)
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()

# # # Read
# #Todays_Opportunity = pd.read_sql('select * from Todays_Opportunity;', con=con) 
vendorticket.to_sql(con=con, name='vendorticket', if_exists='replace',index=False)
con.close()